
#include "MacroPatternMatch.h"

#include "HROOTTreeTTree.h"

#include "TChain.h"

#include "HROOTTreeTChain.h"

using namespace ROOT;

#define CHECKPROTECT(x,y) FXIS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  FXIIF( CHECKPROTECT(cname,mname) ) ( \
  (from_nonconst_to_nonconst<oname,cname ## _t>), \
  (from_nonconst_to_nonconst<cname,cname ## _t>) )

TTREE_DEF_VIRT(TChain)
TNAMED_DEF_VIRT(TChain)
TATTLINE_DEF_VIRT(TChain)
TATTFILL_DEF_VIRT(TChain)
TATTMARKER_DEF_VIRT(TChain)
TOBJECT_DEF_VIRT(TChain)
DELETABLE_DEF_VIRT(TChain)
TCHAIN_DEF_VIRT(TChain)
TCHAIN_DEF_NONVIRT(TChain)
TCHAIN_DEF_ACCESSOR(TChain)

